﻿using ServiceStack.CacheAccess;
using ServiceStack.Common;
using SPS.ServiceCore.API.ServiceModel.Operations;
using ServiceStack.ServiceHost;
using ServiceStack.ServiceInterface;

namespace SPS.ServiceCore.API.ServiceInterface
{
    public class CachedCustomersService : RestServiceBase<CachedCustomers>
    {
        public ICacheClient CacheClient { get; set; }

        public override object OnGet(CachedCustomers request)
        {
            return base.RequestContext.ToOptimizedResultUsingCache(
                this.CacheClient, "urn:customers", () =>
                {
                    var service = this.ResolveService<CustomersService>();
                    return (CustomersResponse)service.Get(new Customers());
                });
        }
    }
}