﻿using System;
using Funq;
using ServiceStack.CacheAccess;
using ServiceStack.CacheAccess.Providers;
using ServiceStack.Common.Utils;
using SPS.ServiceCore.API.ServiceInterface;
using ServiceStack.WebHost.Endpoints;

namespace SPS.ServiceCore.API
{
    public class AppHost : AppHostBase
    {
         // Tell Service Stack the name of your application and where to find your web services
        public AppHost() : base("Flesk Web Services", typeof(CustomersService).Assembly) { }

        public override void Configure(Container container) {
            // Using an in-memory cache
            container.Register<ICacheClient>(new MemoryCacheClient());            

            // Using custom auth provider
            // ??

            // Allow cross domain JavaScript calls (http://openlandscape.wordpress.com/2011/03/21/rest-web-services-with-servicestack/)
            SetConfig(new EndpointHostConfig
            {
                GlobalResponseHeaders =
                {
                    { "Access-Control-Allow-Origin", "*" },
                    { "Access-Control-Allow-Methods", "GET, POST, PUT, DELETE, OPTIONS" },
                },
            });
        }
    }

    public class Global : System.Web.HttpApplication
    {
        protected void Application_Start(object sender, EventArgs e)
        {
            new AppHost().Init();
        }
    }
}